from CvPythonExtensions import *
import PyHelpers
gc = CyGlobalContext()


class Damages:
    
    def __init__(self):
        self.iScaleAmount = 2
        self.iScalePopulation = 5
        self.lBuildingsList = []
        self.lDestroyedBuildingsList = []
    
    def destroyBuildings(self, pCity, bRandom = True, lBuildings = [], iChance = 10, iMaxNumber = -1, bScalesWithNumBuildings = False, bScalesWithPopulation = False):
        numBuildings = 0
        for i in xrange(gc.getNumBuildingInfos()):
            numBuildings += 1
            if pCity.getNumRealBuilding(i) < 1: continue
            ## Info = gc.getBuildingInfo(i)
            ## I commented this out to allow wonders to be destroyed by disasters.
            ## if isLimitedWonderClass(Info.getBuildingClassType()): continue
            self.lBuildingsList.append(i) 
        if bScalesWithNumBuildings:
            iChance += (self.iScaleAmount * numBuildings)
        if bScalesWithPopulation:
            iChance += (self.iScaleAmount * pCity.getPopulation())
        if bRandom:    
            count = 0
            for iBuilding in self.lBuildingsList:
                if iMaxNumber > 0 and count < iMaxNumber:
                    destOdds = CyGame().getSorenRandNum(100,"destroy or not")
                    if destOdds < iChance:
                        count += 1
                        self.lDestroyedBuildingsList.append(iBuilding)
                else:
                    break
        else:
            for iBuilding in lBuildings:
                if iBuilding in self.lBuildingsList:
                    self.lDestroyedBuildingList.append(iBuilding)
        for iBuilding in self.lDestroyedBuildingsList:
            pCity.setNumRealBuilding(iBuilding, 0)
    
    def killPopulation(self, pCity, iNumber = 4, bScalesWithPopulation = False):
        if bScalesWithPopulation:
            iNumber += (pCity.getPopulation() / self.iScalePopulation)
        iKilled = CyGame().getSorenRandNum(iNumber, "killed")
        pCity.changePopulation(-1*iKilled)
    
    def damageUnits(self, pPlot, iNumber = -1, bScalesWithPopulation = False, iAmount = 20, iAmountRand = 10):
        iUnits = pPlot.getNumUnits()
        count = 0
        for i in range(iUnits):
            pUnit = pPlot.getUnit(i)
            if iNumber > 0 and count < iNumber:
                if bScalesWithPopulation and pPlot.isCity():
                    iAmountRand += (self.iScaleAmount * pPlot.getPlotCity().getPopulation())
                iDamage = iAmount + CyGame().getSorenRandNum(2*(iAmountRand),"damage") - iAmountRand
                pUnit.changeDamage(-1*iDamage)
    
    def damageTile(self, pPlot, iPillageChance = 0, iRemoveForestChance = 0, iChangeTerrainChance = 0, iTerrain = -1, bDamageUnits = False):
        if bDamageUnits:
            self.damageUnits(pPlot)
        if iPillageChance > 0:
            pillage = CyGame().getSorenRandNum(100, "pillage")
            if pillage < iPillageChance:
                pPlot.setImprovementType(-1)
        if iRemoveForestChance > 0 and (pPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_FOREST") or pPlot.getFeatureType() == gc.getInfoTypeForString("FEATURE_JUNGLE")):
            remove = CyGame().getSorenRandNum(100, "remove")
            if remove < iRemoveForestChance:
                pPlot.setFeatureType(-1, -1)
        if iChangeTerrainChance > 0 and iTerrain > -1:
            change = CyGame().getSorenRandNum(100, "change")
            if change < iChangeTerrainChance:
                pPlot.setTerrainType(iTerrain)
        